/* Copyright (C) 2002  Martin J. Muench <mjm@codito.de> */

#include "config.h"
#include "crypt.h"
#include "wrap.h"

char *Getpass()
{

	char *buf, *pw;

	buf = getpass("Password: ");
	pw = Malloc(sizeof(char) * strlen(buf));
	if(pw == NULL)
		return NULL;
	pw = Strdup(buf);

  return pw;
}

char *decrypt_buf(char *key, char *buf)
{
	static char temp[768];
	char *stripped;

	memset(temp, 0, sizeof(temp));
	strncpy(temp,decrypt_string(key,buf),sizeof(temp)-1);
	
	#ifdef DEBUG
	debug("Decrypted to: %s", temp);
	#endif

	if(strncmp(temp, SID, strlen(SID)))
		return NULL;
	
	#ifdef DEBUG
	debug("SessinID was correct");
	#endif

	stripped=temp + strlen(SID);
	                  
	return stripped;
}

char *encrypt_buf(char *key, const char *fmt, ...)
{
	static char temp[768];
	char sendbuf[1024];
	char buffer[4096];
	va_list ap;

	memset(buffer, 0, 4096),
	va_start(ap, fmt);
	vsnprintf(buffer, sizeof(buffer)-1, fmt, ap);
	va_end(ap);

	memset(sendbuf, 0, sizeof(sendbuf));
	strncpy(sendbuf, SID, sizeof(sendbuf));
	strncat(sendbuf, buffer, sizeof(sendbuf)-strlen(sendbuf)-1);

	strncpy(temp,encrypt_string(key,sendbuf),sizeof(temp)-1);

	#ifdef DEBUG
	debug("Encrypted to: %s", temp);
	#endif
	
	return temp;
}
