/* Copyright (C) 2002  Martin J. Muench <mjm@codito.de> */

#include "config.h"
#include "sendicmp.h"

int sendpacket(int *rawsock, const char *text, const char *host, int icmpcode, int icmpseq) 
{

	int             pktsize;
	char		*packet, *data;
	struct icmp		*icmp;
	
	pktsize = sizeof(struct icmp) + strlen(text);
        
        if(!(packet = (char *)malloc(pktsize))) 
		return 0;
        
	memset(&data, 0, sizeof(data));

        icmp = (struct icmp *)packet;
        data = (char *)(packet + sizeof(struct icmp));

	memset(packet, 0, pktsize);

	saddr.sin_family = AF_INET;
	saddr.sin_addr.s_addr = inet_addr(host);
	icmp->icmp_type = icmpcode;
	icmp->icmp_cksum = 0;
	icmp->icmp_seq = icmpseq;

	strncpy(data, text, strlen(text));

        icmp->icmp_cksum = in_cksum((u_short *)icmp,sizeof(struct icmp) + strlen(text));

	if (sendto(*rawsock, packet, pktsize, 0, (struct sockaddr *)&saddr, sizeof(struct sockaddr)) < 0 )
		return 0;
  return 1;
}

/* Copied from FreeBSD ping.c  */
int in_cksum (u_short *addr, int len) 
{
	register int nleft = len;
	register u_short *w = addr;
	register int sum = 0;
	u_short answer = 0;
	while (nleft > 1) 
	{
		sum += *w++;
		nleft -= 2;
	}
	if (nleft == 1) 
	{
		*(u_char *)(&answer) = *(u_char *)w;
		sum += answer;
	}	
	sum = (sum >> 16) + (sum & 0xffff);
	sum += (sum >> 16);
	answer = ~sum;
	return (answer);
}
